Index: /palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_mod.f90	(revision 2291)
+++ /palm/trunk/SOURCE/surface_mod.f90	(revision 2292)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
+! includes two more prognostic equations for cloud drop concentration (nc)  
+! and cloud water content (qc). 
+! 
+! 2270 2017-06-09 12:18:47Z maronga
 ! Parameters removed/added due to changes in the LSM
 ! 
@@ -104,4 +109,6 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  qs        !< scaling parameter humidity
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  ss        !< scaling parameter passive scalar
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qcs       !< scaling parameter qc
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  ncs       !< scaling parameter nc
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  qrs       !< scaling parameter qr
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  nrs       !< scaling parameter nr
@@ -124,4 +131,6 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws      !< surface flux latent heat 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  ssws      !< surface flux passive scalar
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qcsws     !< surface flux qc
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  ncsws     !< surface flux nc
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  qrsws     !< surface flux qr
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  nrsws     !< surface flux nr
@@ -719,4 +728,12 @@
 !
 !--       
+       IF ( cloud_physics .AND. microphysics_morrison)  THEN
+          ALLOCATE ( surfaces%qcs(1:surfaces%ns)   )
+          ALLOCATE ( surfaces%ncs(1:surfaces%ns)   )
+          ALLOCATE ( surfaces%qcsws(1:surfaces%ns) )
+          ALLOCATE ( surfaces%ncsws(1:surfaces%ns) )
+       ENDIF
+!
+!--       
        IF ( cloud_physics .AND. microphysics_seifert)  THEN
           ALLOCATE ( surfaces%qrs(1:surfaces%ns)   )
@@ -775,4 +792,10 @@
           ALLOCATE ( surfaces%ssws(1:surfaces%ns) ) 
        ENDIF 
+!
+!--       
+       IF ( cloud_physics .AND. microphysics_morrison)  THEN
+          ALLOCATE ( surfaces%qcsws(1:surfaces%ns) )
+          ALLOCATE ( surfaces%ncsws(1:surfaces%ns) )
+       ENDIF
 !
 !--       
@@ -877,4 +900,11 @@
           ALLOCATE ( surfaces%ssws(1:surfaces%ns) ) 
        ENDIF 
+
+       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+          ALLOCATE ( surfaces%qcs(1:surfaces%ns)   )
+          ALLOCATE ( surfaces%ncs(1:surfaces%ns)   )
+          ALLOCATE ( surfaces%qcsws(1:surfaces%ns) )
+          ALLOCATE ( surfaces%ncsws(1:surfaces%ns) )
+       ENDIF
 
        IF ( cloud_physics .AND. microphysics_seifert)  THEN
@@ -1308,4 +1338,12 @@
              IF ( humidity )  THEN
                 surf%qs(num_h)   = 0.0_wp
+                IF ( cloud_physics .AND. microphysics_morrison)  THEN
+                   surf%qcs(num_h) = 0.0_wp
+                   surf%ncs(num_h) = 0.0_wp
+   
+                   surf%qcsws(num_h) = 0.0_wp
+                   surf%ncsws(num_h) = 0.0_wp
+
+                ENDIF
                 IF ( cloud_physics .AND. microphysics_seifert)  THEN
                    surf%qrs(num_h) = 0.0_wp
@@ -1447,4 +1485,8 @@
              IF ( humidity )  THEN
              surf%qsws = 0.0_wp
+                IF ( cloud_physics  .AND.  microphysics_morrison ) THEN
+                   surf%ncsws = 0.0_wp
+                   surf%qcsws = 0.0_wp
+                ENDIF
                 IF ( cloud_physics  .AND.  microphysics_seifert ) THEN
                    surf%nrsws = 0.0_wp
@@ -1568,4 +1610,11 @@
 !
 !--             Following wall fluxes are assumed to be zero 
+                IF ( cloud_physics .AND. microphysics_morrison)  THEN
+                   surf%qcs(num_v) = 0.0_wp
+                   surf%ncs(num_v) = 0.0_wp
+   
+                   surf%qcsws(num_v) = 0.0_wp
+                   surf%ncsws(num_v) = 0.0_wp
+                ENDIF
                 IF ( cloud_physics .AND. microphysics_seifert)  THEN
                    surf%qrs(num_v) = 0.0_wp
@@ -1656,4 +1705,8 @@
                    IF ( ALLOCATED( surf_def_h(l)%ss ) )                        &
                       surf_h(l)%ss(mm(l))      = surf_def_h(l)%ss(m)
+                   IF ( ALLOCATED( surf_def_h(l)%qcs ) )                       &
+                      surf_h(l)%qcs(mm(l))     = surf_def_h(l)%qcs(m)
+                   IF ( ALLOCATED( surf_def_h(l)%ncs ) )                       &
+                      surf_h(l)%ncs(mm(l))     = surf_def_h(l)%ncs(m)
                    IF ( ALLOCATED( surf_def_h(l)%qrs ) )                       &
                       surf_h(l)%qrs(mm(l))     = surf_def_h(l)%qrs(m)
@@ -1674,4 +1727,6 @@
                    IF ( ALLOCATED( surf_def_h(l)%ssws ) )                      &
                       surf_h(l)%qsws(mm(l))    = surf_def_h(l)%ssws(m)
+                   IF ( ALLOCATED( surf_def_h(l)%ncsws ) )                     &
+                      surf_h(l)%ncsws(mm(l))   = surf_def_h(l)%ncsws(m)
                    IF ( ALLOCATED( surf_def_h(l)%nrsws ) )                     &
                       surf_h(l)%nrsws(mm(l))   = surf_def_h(l)%nrsws(m)
@@ -1693,4 +1748,8 @@
                       IF ( ALLOCATED( surf_lsm_h%ss ) )                        &
                          surf_h(0)%ss(mm(0))      = surf_lsm_h%ss(m)
+                      IF ( ALLOCATED( surf_lsm_h%qcs ) )                       &
+                         surf_h(0)%qcs(mm(0))     = surf_lsm_h%qcs(m)
+                      IF ( ALLOCATED( surf_lsm_h%ncs ) )                       &
+                         surf_h(0)%ncs(mm(0))     = surf_lsm_h%ncs(m)
                       IF ( ALLOCATED( surf_lsm_h%qrs ) )                       &
                          surf_h(0)%qrs(mm(0))     = surf_lsm_h%qrs(m)
@@ -1711,4 +1770,6 @@
                       IF ( ALLOCATED( surf_lsm_h%ssws ) )                      &
                          surf_h(0)%qsws(mm(0))    = surf_lsm_h%ssws(m)
+                      IF ( ALLOCATED( surf_lsm_h%ncsws ) )                     &
+                         surf_h(0)%ncsws(mm(0))   = surf_lsm_h%ncsws(m)
                       IF ( ALLOCATED( surf_lsm_h%nrsws ) )                     &
                          surf_h(0)%nrsws(mm(0))   = surf_lsm_h%nrsws(m)
@@ -1730,4 +1791,8 @@
                       IF ( ALLOCATED( surf_usm_h%ss ) )                        &
                          surf_h(0)%ss(mm(0))      = surf_usm_h%ss(m)
+                      IF ( ALLOCATED( surf_usm_h%qcs ) )                       &
+                         surf_h(0)%qcs(mm(0))     = surf_usm_h%qcs(m)
+                      IF ( ALLOCATED( surf_usm_h%ncs ) )                       &
+                         surf_h(0)%ncs(mm(0))     = surf_usm_h%ncs(m)
                       IF ( ALLOCATED( surf_usm_h%qrs ) )                       &
                          surf_h(0)%qrs(mm(0))     = surf_usm_h%qrs(m)
@@ -1748,4 +1813,6 @@
                       IF ( ALLOCATED( surf_usm_h%ssws ) )                      &
                          surf_h(0)%qsws(mm(0))    = surf_usm_h%ssws(m)
+                      IF ( ALLOCATED( surf_usm_h%ncsws ) )                     &
+                         surf_h(0)%ncsws(mm(0))   = surf_usm_h%ncsws(m)
                       IF ( ALLOCATED( surf_usm_h%nrsws ) )                     &
                          surf_h(0)%nrsws(mm(0))   = surf_usm_h%nrsws(m)
@@ -1791,4 +1858,8 @@
                    IF ( ALLOCATED( surf_def_v(l)%ss ) )                        &
                       surf_v(l)%ss(mm(l))      = surf_def_v(l)%ss(m)
+                   IF ( ALLOCATED( surf_def_v(l)%qcs ) )                       &
+                      surf_v(l)%qcs(mm(l))     = surf_def_v(l)%qcs(m)
+                   IF ( ALLOCATED( surf_def_v(l)%ncs ) )                       &
+                      surf_v(l)%ncs(mm(l))     = surf_def_v(l)%ncs(m)
                    IF ( ALLOCATED( surf_def_v(l)%qrs ) )                       &
                       surf_v(l)%qrs(mm(l))     = surf_def_v(l)%qrs(m)
@@ -1805,4 +1876,6 @@
                    IF ( ALLOCATED( surf_def_v(l)%ssws ) )                      &
                       surf_v(l)%qsws(mm(l))    = surf_def_v(l)%ssws(m)
+                   IF ( ALLOCATED( surf_def_v(l)%ncsws ) )                     &
+                      surf_v(l)%ncsws(mm(l))   = surf_def_v(l)%ncsws(m)
                    IF ( ALLOCATED( surf_def_v(l)%nrsws ) )                     &
                       surf_v(l)%nrsws(mm(l))   = surf_def_v(l)%nrsws(m)
@@ -1829,4 +1902,8 @@
                    IF ( ALLOCATED( surf_lsm_v(l)%ss ) )                        &
                       surf_v(l)%ss(mm(l))      = surf_lsm_v(l)%ss(m)
+                   IF ( ALLOCATED( surf_lsm_v(l)%qcs ) )                       &
+                      surf_v(l)%qcs(mm(l))     = surf_lsm_v(l)%qcs(m)
+                   IF ( ALLOCATED( surf_lsm_v(l)%ncs ) )                       &
+                      surf_v(l)%ncs(mm(l))     = surf_lsm_v(l)%ncs(m)
                    IF ( ALLOCATED( surf_lsm_v(l)%qrs ) )                       &
                       surf_v(l)%qrs(mm(l))     = surf_lsm_v(l)%qrs(m)
@@ -1847,4 +1924,6 @@
                    IF ( ALLOCATED( surf_lsm_v(l)%ssws ) )                      &
                       surf_v(l)%qsws(mm(l))    = surf_lsm_v(l)%ssws(m)
+                   IF ( ALLOCATED( surf_lsm_v(l)%ncsws ) )                     &
+                      surf_v(l)%ncsws(mm(l))   = surf_lsm_v(l)%ncsws(m)
                    IF ( ALLOCATED( surf_lsm_v(l)%nrsws ) )                     &
                       surf_v(l)%nrsws(mm(l))   = surf_lsm_v(l)%nrsws(m)
@@ -1871,4 +1950,8 @@
                    IF ( ALLOCATED( surf_usm_v(l)%ss ) )                        &
                       surf_v(l)%ss(mm(l))      = surf_usm_v(l)%ss(m)
+                   IF ( ALLOCATED( surf_usm_v(l)%qcs ) )                       &
+                      surf_v(l)%qcs(mm(l))     = surf_usm_v(l)%qcs(m)
+                   IF ( ALLOCATED( surf_usm_v(l)%ncs ) )                       &
+                      surf_v(l)%ncs(mm(l))     = surf_usm_v(l)%ncs(m)
                    IF ( ALLOCATED( surf_usm_v(l)%qrs ) )                       &
                       surf_v(l)%qrs(mm(l))     = surf_usm_v(l)%qrs(m)
@@ -1889,4 +1972,6 @@
                    IF ( ALLOCATED( surf_usm_v(l)%ssws ) )                      &
                       surf_v(l)%qsws(mm(l))    = surf_usm_v(l)%ssws(m)
+                   IF ( ALLOCATED( surf_usm_v(l)%ncsws ) )                     &
+                      surf_v(l)%ncsws(mm(l))   = surf_usm_v(l)%ncsws(m)
                    IF ( ALLOCATED( surf_usm_v(l)%nrsws ) )                     &
                       surf_v(l)%nrsws(mm(l))   = surf_usm_v(l)%nrsws(m)
@@ -1946,4 +2031,12 @@
              WRITE ( 14 )  surf_h(l)%ss
           ENDIF
+          WRITE ( 14 )  'surf_h(' // dum // ')%qcs                 '
+          IF ( ALLOCATED ( surf_h(l)%qcs ) )  THEN  
+             WRITE ( 14 )  surf_h(l)%qcs
+          ENDIF
+          WRITE ( 14 )  'surf_h(' // dum // ')%ncs                 '  
+          IF ( ALLOCATED ( surf_h(l)%ncs ) )  THEN
+             WRITE ( 14 )  surf_h(l)%ncs
+          ENDIF
           WRITE ( 14 )  'surf_h(' // dum // ')%qrs                 '
           IF ( ALLOCATED ( surf_h(l)%qrs ) )  THEN  
@@ -1981,4 +2074,12 @@
           IF ( ALLOCATED ( surf_h(l)%ssws ) )  THEN 
              WRITE ( 14 )  surf_h(l)%ssws
+          ENDIF
+          WRITE ( 14 )  'surf_h(' // dum // ')%qcsws               '  
+          IF ( ALLOCATED ( surf_h(l)%qcsws ) )  THEN
+             WRITE ( 14 )  surf_h(l)%qcsws
+          ENDIF
+          WRITE ( 14 )  'surf_h(' // dum // ')%ncsws               '  
+          IF ( ALLOCATED ( surf_h(l)%ncsws ) )  THEN
+             WRITE ( 14 )  surf_h(l)%ncsws
           ENDIF
           WRITE ( 14 )  'surf_h(' // dum // ')%qrsws               '  
@@ -2021,4 +2122,12 @@
              WRITE ( 14 )  surf_v(l)%ss
           ENDIF
+          WRITE ( 14 )  'surf_v(' // dum // ')%qcs                 '  
+          IF ( ALLOCATED ( surf_v(l)%qcs ) )  THEN
+             WRITE ( 14 )  surf_v(l)%qcs
+          ENDIF
+          WRITE ( 14 )  'surf_v(' // dum // ')%ncs                 ' 
+          IF ( ALLOCATED ( surf_v(l)%ncs ) )  THEN 
+             WRITE ( 14 )  surf_v(l)%ncs
+          ENDIF
           WRITE ( 14 )  'surf_v(' // dum // ')%qrs                 '  
           IF ( ALLOCATED ( surf_v(l)%qrs ) )  THEN
@@ -2048,4 +2157,12 @@
           IF ( ALLOCATED ( surf_v(l)%ssws ) )  THEN
              WRITE ( 14 )  surf_v(l)%ssws
+          ENDIF
+          WRITE ( 14 )  'surf_v(' // dum // ')%qcsws               '  
+          IF ( ALLOCATED ( surf_v(l)%qcsws ) )  THEN
+             WRITE ( 14 )  surf_v(l)%qcsws
+          ENDIF
+          WRITE ( 14 )  'surf_v(' // dum // ')%ncsws               '  
+          IF ( ALLOCATED ( surf_v(l)%ncsws ) )  THEN
+             WRITE ( 14 )  surf_v(l)%ncsws
           ENDIF
           WRITE ( 14 )  'surf_v(' // dum // ')%qrsws               '  
@@ -2240,4 +2357,10 @@
                       IF ( ALLOCATED( surf_h(0)%ss )  .AND.  kk == 1 )         &
                          READ ( 13 )  surf_h(0)%ss
+                   CASE ( 'surf_h(0)%qcs' )         
+                      IF ( ALLOCATED( surf_h(0)%qcs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_h(0)%qcs
+                   CASE ( 'surf_h(0)%ncs' )         
+                      IF ( ALLOCATED( surf_h(0)%ncs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_h(0)%ncs
                    CASE ( 'surf_h(0)%qrs' )         
                       IF ( ALLOCATED( surf_h(0)%qrs )  .AND.  kk == 1 )        &
@@ -2267,4 +2390,10 @@
                       IF ( ALLOCATED( surf_h(0)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_h(0)%ssws
+                   CASE ( 'surf_h(0)%qcsws' )         
+                      IF ( ALLOCATED( surf_h(0)%qcsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_h(0)%qcsws
+                   CASE ( 'surf_h(0)%ncsws' )         
+                      IF ( ALLOCATED( surf_h(0)%ncsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_h(0)%ncsws
                    CASE ( 'surf_h(0)%qrsws' )         
                       IF ( ALLOCATED( surf_h(0)%qrsws )  .AND.  kk == 1 )      &
@@ -2296,4 +2425,10 @@
                       IF ( ALLOCATED( surf_h(1)%ss )  .AND.  kk == 1 )         &
                          READ ( 13 )  surf_h(1)%ss
+                   CASE ( 'surf_h(1)%qcs' )         
+                      IF ( ALLOCATED( surf_h(1)%qcs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_h(1)%qcs
+                   CASE ( 'surf_h(1)%ncs' )         
+                      IF ( ALLOCATED( surf_h(1)%ncs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_h(1)%ncs
                    CASE ( 'surf_h(1)%qrs' )         
                       IF ( ALLOCATED( surf_h(1)%qrs )  .AND.  kk == 1 )        &
@@ -2323,4 +2458,10 @@
                       IF ( ALLOCATED( surf_h(1)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_h(1)%ssws
+                   CASE ( 'surf_h(1)%qcsws' )         
+                      IF ( ALLOCATED( surf_h(1)%qcsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_h(1)%qcsws
+                   CASE ( 'surf_h(1)%ncsws' )         
+                      IF ( ALLOCATED( surf_h(1)%ncsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_h(1)%ncsws
                    CASE ( 'surf_h(1)%qrsws' )         
                       IF ( ALLOCATED( surf_h(1)%qrsws )  .AND.  kk == 1 )      &
@@ -2352,4 +2493,10 @@
                       IF ( ALLOCATED( surf_h(2)%ss )  .AND.  kk == 1 )         &
                          READ ( 13 )  surf_h(2)%ss
+                   CASE ( 'surf_h(2)%qcs' )         
+                      IF ( ALLOCATED( surf_h(2)%qcs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_h(2)%qcs
+                   CASE ( 'surf_h(2)%ncs' )         
+                      IF ( ALLOCATED( surf_h(2)%ncs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_h(2)%ncs
                    CASE ( 'surf_h(2)%qrs' )         
                       IF ( ALLOCATED( surf_h(2)%qrs )  .AND.  kk == 1 )        &
@@ -2379,4 +2526,10 @@
                       IF ( ALLOCATED( surf_h(2)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_h(2)%ssws
+                   CASE ( 'surf_h(2)%qcsws' )         
+                      IF ( ALLOCATED( surf_h(2)%qcsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_h(2)%qcsws
+                   CASE ( 'surf_h(2)%ncsws' )         
+                      IF ( ALLOCATED( surf_h(2)%ncsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_h(2)%ncsws
                    CASE ( 'surf_h(2)%qrsws' )         
                       IF ( ALLOCATED( surf_h(2)%qrsws )  .AND.  kk == 1 )      &
@@ -2410,4 +2563,10 @@
                       IF ( ALLOCATED( surf_v(0)%ss )  .AND.  kk == 1 )         &
                          READ ( 13 )  surf_v(0)%ss
+                   CASE ( 'surf_v(0)%qcs' )         
+                      IF ( ALLOCATED( surf_v(0)%qcs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_v(0)%qcs
+                   CASE ( 'surf_v(0)%ncs' )         
+                      IF ( ALLOCATED( surf_v(0)%ncs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_v(0)%ncs
                    CASE ( 'surf_v(0)%qrs' )         
                       IF ( ALLOCATED( surf_v(0)%qrs )  .AND.  kk == 1 )        &
@@ -2431,4 +2590,10 @@
                       IF ( ALLOCATED( surf_v(0)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_v(0)%ssws
+                   CASE ( 'surf_v(0)%qcsws' )         
+                      IF ( ALLOCATED( surf_v(0)%qcsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_v(0)%qcsws
+                   CASE ( 'surf_v(0)%ncsws' )         
+                      IF ( ALLOCATED( surf_v(0)%ncsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_v(0)%ncsws
                    CASE ( 'surf_v(0)%qrsws' )         
                       IF ( ALLOCATED( surf_v(0)%qrsws )  .AND.  kk == 1 )      &
@@ -2469,4 +2634,10 @@
                       IF ( ALLOCATED( surf_v(1)%ss )  .AND.  kk == 1 )         &
                          READ ( 13 )  surf_v(1)%ss
+                   CASE ( 'surf_v(1)%qcs' )         
+                      IF ( ALLOCATED( surf_v(1)%qcs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_v(1)%qcs
+                   CASE ( 'surf_v(1)%ncs' )         
+                      IF ( ALLOCATED( surf_v(1)%ncs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_v(1)%ncs
                    CASE ( 'surf_v(1)%qrs' )         
                       IF ( ALLOCATED( surf_v(1)%qrs )  .AND.  kk == 1 )        &
@@ -2490,4 +2661,10 @@
                       IF ( ALLOCATED( surf_v(1)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_v(1)%ssws
+                   CASE ( 'surf_v(1)%qcsws' )         
+                      IF ( ALLOCATED( surf_v(1)%qcsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_v(1)%qcsws
+                   CASE ( 'surf_v(1)%ncsws' )         
+                      IF ( ALLOCATED( surf_v(1)%ncsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_v(1)%ncsws
                    CASE ( 'surf_v(1)%qrsws' )         
                       IF ( ALLOCATED( surf_v(1)%qrsws )  .AND.  kk == 1 )      &
@@ -2528,4 +2705,10 @@
                       IF ( ALLOCATED( surf_v(2)%ss )  .AND.  kk == 1 )         &
                          READ ( 13 )  surf_v(2)%ss
+                   CASE ( 'surf_v(2)%qcs' )         
+                      IF ( ALLOCATED( surf_v(2)%qcs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_v(2)%qcs
+                   CASE ( 'surf_v(2)%ncs' )         
+                      IF ( ALLOCATED( surf_v(2)%ncs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_v(2)%ncs
                    CASE ( 'surf_v(2)%qrs' )         
                       IF ( ALLOCATED( surf_v(2)%qrs )  .AND.  kk == 1 )        &
@@ -2549,4 +2732,10 @@
                       IF ( ALLOCATED( surf_v(2)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_v(2)%ssws
+                   CASE ( 'surf_v(2)%qcsws' )         
+                      IF ( ALLOCATED( surf_v(2)%qcsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_v(2)%qcsws
+                   CASE ( 'surf_v(2)%ncsws' )         
+                      IF ( ALLOCATED( surf_v(2)%ncsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_v(2)%ncsws
                    CASE ( 'surf_v(2)%qrsws' )         
                       IF ( ALLOCATED( surf_v(2)%qrsws )  .AND.  kk == 1 )      &
@@ -2587,4 +2776,10 @@
                       IF ( ALLOCATED( surf_v(3)%ss )  .AND.  kk == 1 )         &
                          READ ( 13 )  surf_v(3)%ss
+                   CASE ( 'surf_v(3)%qcs' )         
+                      IF ( ALLOCATED( surf_v(3)%qcs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_v(3)%qcs
+                   CASE ( 'surf_v(3)%ncs' )         
+                      IF ( ALLOCATED( surf_v(3)%ncs )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_v(3)%ncs
                    CASE ( 'surf_v(3)%qrs' )         
                       IF ( ALLOCATED( surf_v(3)%qrs )  .AND.  kk == 1 )        &
@@ -2608,4 +2803,10 @@
                       IF ( ALLOCATED( surf_v(3)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_v(3)%ssws
+                   CASE ( 'surf_v(3)%qcsws' )         
+                      IF ( ALLOCATED( surf_v(3)%qcsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_v(3)%qcsws
+                   CASE ( 'surf_v(3)%ncsws' )         
+                      IF ( ALLOCATED( surf_v(3)%ncsws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_v(3)%ncsws
                    CASE ( 'surf_v(3)%qrsws' )         
                       IF ( ALLOCATED( surf_v(3)%qrsws )  .AND.  kk == 1 )      &
@@ -2814,4 +3015,28 @@
              ENDIF
 
+             IF ( SCAN( TRIM( field_chr ), '%qcs' ) /= 0 )  THEN 
+                IF ( ALLOCATED( surf_target%qcs )  .AND.                       &
+                     ALLOCATED( surf_file%qcs   ) )                            & 
+                  surf_target%qcs(m_target) = surf_file%qcs(m_file)
+             ENDIF
+
+             IF ( SCAN( TRIM( field_chr ), '%qcsws' ) /= 0 )  THEN 
+                IF ( ALLOCATED( surf_target%qcsws )  .AND.                     &
+                     ALLOCATED( surf_file%qcsws   ) )                          & 
+                   surf_target%qcsws(m_target) = surf_file%qcsws(m_file)
+             ENDIF
+
+             IF ( SCAN( TRIM( field_chr ), '%ncs' ) /= 0 )  THEN 
+                IF ( ALLOCATED( surf_target%ncs )  .AND.                       &
+                     ALLOCATED( surf_file%ncs   ) )                            & 
+                   surf_target%ncs(m_target) = surf_file%ncs(m_file)
+             ENDIF
+
+             IF ( SCAN( TRIM( field_chr ), '%ncsws' ) /= 0 )  THEN 
+                IF ( ALLOCATED( surf_target%ncsws )  .AND.                     &
+                     ALLOCATED( surf_file%ncsws   ) )                          & 
+                   surf_target%ncsws(m_target) = surf_file%ncsws(m_file)
+             ENDIF
+
              IF ( SCAN( TRIM( field_chr ), '%qrs' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qrs )  .AND.                       &
Index: /palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- /palm/trunk/SOURCE/swap_timelevel.f90	(revision 2291)
+++ /palm/trunk/SOURCE/swap_timelevel.f90	(revision 2292)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
+! includes two more prognostic equations for cloud drop concentration (nc)  
+! and cloud water content (qc). 
+! 
+! 2233 2017-05-30 18:08:54Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
@@ -103,11 +108,12 @@
 #if defined( __nopointer )
     USE arrays_3d,                                                             &
-        ONLY:  e, e_p, nr, nr_p, pt, pt_p, q, q_p, qr, qr_p, s, s_p, sa, sa_p, &
-               u, u_p, v, v_p, w, w_p
+        ONLY:  e, e_p, nc, nc_p, nr, nr_p, pt, pt_p, q, q_p, qc, qc_p qr, qr_p,&
+               s, s_p, sa, sa_p, u, u_p, v, v_p, w, w_p
 #else
     USE arrays_3d,                                                             &
-        ONLY:  e, e_1, e_2, e_p, nr, nr_1, nr_2, nr_p, pt, pt_1, pt_2, pt_p, q,&
-               q_1, q_2, q_p, qr, qr_1, qr_2, qr_p, s, s_1, s_2, s_p, sa, sa_1,&
-               sa_2, sa_p, u, u_1, u_2, u_p, v, v_1, v_2, v_p, w, w_1, w_2, w_p
+        ONLY:  e, e_1, e_2, e_p, nc, nc_1, nc_2, nc_p, nr, nr_1, nr_2, nr_p,   &
+               pt, pt_1, pt_2, pt_p, q, q_1, q_2, q_p, qc, qc_1, qc_2, qc_p,   &
+               qr, qr_1, qr_2, qr_p, s, s_1, s_2, s_p, sa, sa_1, sa_2, sa_p,   &
+               u, u_1, u_2, u_p, v, v_1, v_2, v_p, w, w_1, w_2, w_p
 
 #endif
@@ -121,6 +127,6 @@
     USE control_parameters,                                                    &
         ONLY:  cloud_physics, constant_diffusion, humidity, land_surface,      &
-               microphysics_seifert, neutral, ocean, passive_scalar,           &
-               timestep_count, urban_surface
+               microphysics_morrison, microphysics_seifert, neutral, ocean,    &
+               passive_scalar, timestep_count, urban_surface
 
     USE indices,                                                               &
@@ -174,5 +180,9 @@
 
     IF ( humidity )  THEN
-       q = q_p             
+       q = q_p
+       IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+          qc = qc_p
+          nc = nc_p
+       ENDIF             
        IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
           qr = qr_p
@@ -214,4 +224,8 @@
           IF ( humidity )  THEN
              q => q_1;    q_p => q_2
+             IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                qc => qc_1;    qc_p => qc_2
+                nc => nc_1;    nc_p => nc_2
+             ENDIF
              IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
                 qr => qr_1;    qr_p => qr_2
@@ -241,4 +255,8 @@
           IF ( humidity )  THEN
              q => q_2;    q_p => q_1
+             IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                qc => qc_2;    qc_p => qc_1
+                nc => nc_2;    nc_p => nc_1
+             ENDIF
              IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
                 qr => qr_2;    qr_p => qr_1
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 2291)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 2292)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
+! includes two more prognostic equations for cloud drop concentration (nc)  
+! and cloud water content (qc). 
+! 
+! 2271 2017-06-09 12:34:55Z sward
 ! Start timestep message changed
 ! 
@@ -267,7 +272,8 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  diss, dzu, e, e_p, nr, nr_p, prho, pt, pt_p, pt_init, q_init, q,&
-               ql, ql_c, ql_v, ql_vp, qr, qr_p, q_p, ref_state, rho_ocean,     &
-               s, s_p, sa_p, tend, u, u_p, v, vpt, v_p, w, w_p
+        ONLY:  diss, dzu, e, e_p, nc, nc_p, nr, nr_p, prho, pt, pt_p, pt_init, &
+               q_init, q, qc, qc_p, ql, ql_c, ql_v, ql_vp, qr, qr_p, q_p,      &
+               ref_state, rho_ocean, s, s_p, sa_p, tend, u, u_p, v, vpt,       &
+               v_p, w, w_p
 
     USE calc_mean_profile_mod,                                                 &
@@ -291,5 +297,5 @@
                land_surface, large_scale_forcing,                              &
                loop_optimization, lsf_surf, lsf_vert, masks,                   &
-               microphysics_seifert, mid, nest_domain,                         &
+               microphysics_morrison, microphysics_seifert, mid, nest_domain,  &
                neutral, nr_timesteps_this_run, nudging,                        &
                ocean, passive_scalar,                                          &
@@ -585,4 +591,8 @@
           IF ( humidity )  THEN
              CALL exchange_horiz( q_p, nbgp )
+             IF ( cloud_physics .AND. microphysics_morrison )  THEN
+                CALL exchange_horiz( qc_p, nbgp )
+                CALL exchange_horiz( nc_p, nbgp )
+             ENDIF
              IF ( cloud_physics .AND. microphysics_seifert )  THEN
                 CALL exchange_horiz( qr_p, nbgp )
@@ -637,8 +647,10 @@
                    CALL exchange_horiz( q, nbgp )
 
+                   IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                       CALL exchange_horiz( qc, nbgp )
+                       CALL exchange_horiz( nc, nbgp )
+                   ENDIF
                    IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-!                        CALL exchange_horiz( qc, nbgp )
                        CALL exchange_horiz( qr, nbgp )
-!                        CALL exchange_horiz( nc, nbgp )
                        CALL exchange_horiz( nr, nbgp )
                    ENDIF
